/*
			Copyright (c) 1994 by
			Advanced Visual Systems Inc.
			All Rights Reserved

	This software comprises unpublished confidential information of
	Advanced Visual Systems Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.

	This file is under Perforce control
	$Id: //depot/express/fcs992/include/avs/dv_util.h#1 $
*/

#ifdef __cplusplus
extern "C" {
#endif

/* blk_tbl.c */
int UTILinterp_init PTARGS((char *field_table, char **block_table));
int UTILinterp_init_struct PTARGS((char *field_table, char **block_table));
int UTILinterp_init_unif PTARGS((char *field_table, char **block_table));
int UTILinterp_init_rect PTARGS((char *field_table, char **block_table));
/* cell.c */
int UTILcell_to_node PTARGS((char *field_table, int set, int dtype, 
                             char *cell_data, int veclen, int null_flag, 
                             char *null_value, int order, char *node_data,
                             char **ptr, char **ptr_null));
/* cell_fnd.c */
int UTILfind_cell PTARGS((char *field_table, char *block_table, float *point, int *cell, float *uvw));
int UTILfind_cell_unif PTARGS((char *field_table, char *block_table, float *point, int *cell, float *uvw));
int UTILfind_cell_rect PTARGS((char *field_table, char *block_table, float *point, int *cell, float *uvw));
int UTILcell_extent PTARGS((char *field_table, int cell, float *min_ext, float *max_ext));
int UTILcell_extent_struct PTARGS((char *field_table, int cell, float *min_ext, float *max_ext));
int UTILcell_extent_unif PTARGS((char *field_table, int cell, float *min_ext, float *max_ext));
int UTILcell_extent_rect PTARGS((char *field_table, int cell, float *min_ext, float *max_ext));
int UTILget_cell_id PTARGS((char *field_table, int cell, int *cell_id, int *set));
/* con_stct.c */
int UTILcontour_struct PTARGS((char *field_table, char *node_data, int dtype, int null_flag, char *null_value, 
			       double iso_val1, double iso_val2, int *old_nnodes, int **old_nlist, int *new_nnodes, 
			       int **min_nodes, int **max_nodes, char **list, int *out_ncells, int **out_conn_list, 
			       int *conn_size, int nspace, float **xyz, 
			       int *nline1, int **line_conn1, int *nline2, int **line_conn2));
/* contr.c */
int UTILcontour PTARGS((char *field_table, char *node_data, int data_type, int null_data_flag, 
			char *null_data_value, double level1, double level2, int *old_nnodes, int **node_ind, 
			int *new_nnodes, int **min_nodes, int **max_nodes, char **list, int *out_ncells, 
			int **out_conn_list, int *conn_size, int nspace, float **xyz, 
			       int *nline1, int **line_conn1, int *nline2, int **line_conn2));
int UTILcontour_cells PTARGS((char *cell_table, char *node_data, int data_type, 
			      int null_data_flag, char *null_data_value, double level1, double level2, int *old_nnodes, 
			      int **node_ind, int *new_nnodes, int **min_nodes, int **max_nodes, char **list, int *out_ncells, 
			      int **out_conn_list, int *conn_size, int nspace, float **xyz,
                              int *nline1, int **line_conn1, int *nline2, int **line_conn2));
int UTILnode_thresh2 PTARGS((int nnodes, int data_type, char *node_data, int null_flag, char *null_value, 
			     double level1, double level2, int *node_ind));
int UTILedge_table2_add_points PTARGS((char *edge_table, int *node1_list, int *node2_list, 
				       int npts, int *flag, int *pts));
int UTILedge_table2_get_free PTARGS((char *edge_table, int **min_node_list, int **max_node_list, int *size, char **list));
char *UTILedge_table2_create PTARGS((int size));
int UTILedge_table2_delete PTARGS((char *edge_table));
int UTILeval_contour PTARGS((int n, int nnodes, int nstart, int dtype, char *node_data, double level1, double level2, int *min_node_list, int *max_node_list, char *list, int veclen, int in_type, int null_flag, char *null_value, int offset, char *in_data, char *out_data));
/* cut_fnc.c */
int UTILcut PTARGS((char *field_table, char *node_data, int data_type, int null_data_flag, char *null_data_value,
		    double level, int dir, int *old_nnodes, int **node_ind, 
		    int *new_nnodes, int **min_nodes, int **max_nodes, int *out_ncells, int **out_conn_list, int *conn_size, int *ncell, int **cell_ind));
int UTILcut_cells PTARGS((char *cell_table, char *node_data, int data_type, int null_data_flag, char *null_data_value,
			  double level, int dir, int *old_nnodes, int **node_ind, int *new_nnodes, 
			  int **min_nodes, int **max_nodes, int *out_ncells, int **out_conn_list, int *conn_size, int *ncell, int **cell_ind));
int UTILnode_thresh PTARGS((int nnodes, int data_type, char *node_data, int null_flag, char *null_value, 
			    double level, int dir, int *node_ind));
/* cut_stct.c */
int UTILcut_struct PTARGS((char *field_table, char *node_data, int dtype, int null_flag, char *null_value,
			   double iso_val, int dir, int *old_nnodes, int **old_nlist, 
			   int *new_nnodes, int **min_nodes, int **max_nodes, int *out_ncells, 
			   int **out_conn_list, int *conn_size, int *ncell, int **cell_ind));
/* data_fnc.c */
int UTILcopy_array_list PTARGS((int n, int veclen, int dtype, char *data, 
                                int size, int *list, char *out_data));
int UTILextract_vector PTARGS((int nnodes, int *in_veclen, char **in_data, int dtype, 
			       int out_veclen, int *subcomp, char *out_data));
int UTILextract_scalar PTARGS((int nnodes, int in_veclen, char *in_data, 
                               int dtype, int comp, char *out_data));
int UTILthreshold PTARGS((int nnodes, char *thresh_data, int thresh_veclen, int thresh_comp, 
			  int thresh_type, int null_flag, char *null_value, int below, double min_val, 
			  int above, double max_val, char *in_data, int in_veclen, int in_type, 
			  double in_null_value, char *out_data));
int UTILclamp PTARGS((int nnodes, char *in_data, int clamp_veclen, int clamp_comp, int dtype, 
		      int null_flag, char *null_value, int below, double min_val, int above, double max_val, char *out_data));
int UTILdownsize PTARGS((int ndim, int *dims, int *stride, int dtype, char *in_data, char *out_data));
int UTILresample PTARGS((int ndim, int *dims, int *rdims, int veclen, int dtype, char *in_data, char *out_data));
int  UTILfilter_1d PTARGS((int nkern, float *kernels, int n, int veclen, 
                           int dtype, char  *in_data, char *out_data));
int  UTILinterpolate PTARGS((int n, double t, int dtype, char *in_data1, 
                             char *in_data2, char *out_data));
/* delaun_2.c */
int UTILdelaun_tess_2D PTARGS((int nnodes, float *in_xyz, int nspace, float *min_ext, float *max_ext, 
			       int check, int *nsimp, int **connect_list));
int x_compare_2 PTARGS((char *a, char *b));
/* delaun_3.c */
int UTILdelaun_tess_3D PTARGS((int nnodes, float *in_xyz, float *min_ext, float *max_ext, 
			       int check, int *nsimp, int **connect_list));
int x_compare PTARGS((char *a, char *b));
/* deriv.c */
int UTILderiv_3d PTARGS((char *field_table, int cell, int veclen, char *node_data, int dtype, 
			 int null_flag, char *null_value, float *uvw, float *deriv));
int UTILderiv_2d PTARGS((char *field_table, int cell, int veclen, char *node_data, int dtype, 
			 int null_flag, char *null_value, float *uvw, float *deriv, float xform[3][3], float xyz_loc[][3]));
int UTILderiv_cell_3d PTARGS((char *field_table, int cell, int veclen, char *node_data, int dtype, 
			      int null_flag, char *null_value, float *uvw, float *deriv));
int UTILderiv_cell_2d PTARGS((char *field_table, int cell, int veclen, char *node_data, int dtype, 
			      int null_flag, char *null_value, float *uvw, float *deriv, float xform[3][3], float xyz_loc[][3]));
int UTILderiv_struct_3d PTARGS((char *field_table, int cell, int veclen, char *node_data, int dtype, 
				int null_flag, char *null_value, float *uvw, float *deriv));
int UTILderiv_struct_2d PTARGS((char *field_table, int cell, int veclen, char *node_data, int dtype, 
				int null_flag, char *null_value, float *uvw, float *deriv, float xform[3][3], float xyz_loc[][3]));
int UTILderiv_unif_3d PTARGS((char *field_table, int cell, int veclen, char *node_data, 
			      int dtype, int null_flag, char *null_value, float *uvw, float *deriv));
int UTILderiv_unif_2d PTARGS((char *field_table, int cell, int veclen, char *node_data, 
			      int dtype, int null_flag, char *null_value, float *uvw, float *deriv, float xform[3][3], float xyz_loc[][3]));
int UTILderiv_rect_3d PTARGS((char *field_table, int cell, int veclen, char *node_data, 
			      int dtype, int null_flag, char *null_value, float *uvw, float *deriv));
int UTILderiv_rect_2d PTARGS((char *field_table, int cell, int veclen, char *node_data, 
			      int dtype, int null_flag, char *null_value, float *uvw, float *deriv, float xform[3][3], float xyz_loc[][3]));
/* derv_fnc.c */
int UTILgrad PTARGS((char *mesh_info, char *node_data, int veclen, int dtype, int null_flag, char *null_value, float *grad));
int UTILcurl PTARGS((char *mesh_info, char *node_data, int veclen, int dtype, int null_flag, char *null_value, float *curl));
int UTILdiv PTARGS((char *mesh_info, char *node_data, int veclen, int dtype, int null_flag, char *null_value, float *div));
int UTILgrad_cell PTARGS((char *mesh_info, int cell_ndim, int cell, char *node_data, 
			  int dtype, int null_flag, char *null_value, int n, float *uvw, float *grad));
int UTILcurl_cell PTARGS((char *mesh_info, int cell_ndim, int cell, char *node_data, int veclen, int dtype, int null_flag, char *null_value, int n, float *uvw, float *curl));
int UTILdiv_cell PTARGS((char *mesh_info, int cell_ndim, int cell, char *node_data, 
			 int veclen, int dtype, int null_flag, char *null_value, int n, float *uvw, float *div));
int UTILgrad_cells PTARGS((char *mesh_info, char *node_data, int veclen, 
			   int dtype, int null_flag, char *null_value, float *grad));
int UTILcurl_cells PTARGS((char *mesh_info, char *node_data, int veclen, 
			   int dtype, int null_flag, char *null_value, float *curl));
int UTILdiv_cells PTARGS((char *mesh_info, char *node_data, int veclen, 
			  int dtype, int null_flag, char *null_value, float *div));
int UTILgrad_struct PTARGS((char *mesh_info, char *node_data, int veclen, 
			    int dtype, int null_flag, char *null_value, float *grad));
int UTILgrad_unif PTARGS((char *mesh_info, char *node_data, int veclen, 
			  int dtype, int null_flag, char *null_value, float *grad));
int UTILgrad_rect PTARGS((char *mesh_info, char *node_data, int veclen, 
			  int dtype, int null_flag, char *null_value, float *grad));
int UTILcurl_struct PTARGS((char *mesh_info, char *node_data, int veclen, 
			    int dtype, int null_flag, char *null_value, float *curl));
int UTILcurl_unif PTARGS((char *mesh_info, char *node_data, int veclen, 
			  int dtype, int null_flag, char *null_value, float *curl));
int UTILcurl_rect PTARGS((char *mesh_info, char *node_data, int veclen, 
			  int dtype, int null_flag, char *null_value, float *curl));
int UTILdiv_struct PTARGS((char *mesh_info, char *node_data, int veclen, 
			   int dtype, int null_flag, char *null_value, float *div));
int UTILdiv_unif PTARGS((char *mesh_info, char *node_data, int veclen, 
			 int dtype, int null_flag, char *null_value, float *div));
int UTILdiv_rect PTARGS((char *mesh_info, char *node_data, int veclen, 
			 int dtype, int null_flag, char *null_value, float *div));
/* edge.c */
int UTILedges_2D PTARGS((int nnodes, int ncells, int cell_nnodes, int *node_list, 
                  int cell_corner_nnodes, int *out_ncells, int **out_node_list));
int UTILedges_3D PTARGS((int nnodes, int ncells, int cell_nnodes, int *node_list, 
                 int nfaces, int *face_nnodes, int *face_corner_nnodes, int *face_node_list,
                 int *out_ncells, int **out_node_list));

/* edge_ext.c */
int UTILexternal_edges PTARGS((int nnodes, int nspace, float *xyz, int nfaces, int face_nnodes, 
			       int face_corner_nnodes, int *node_list, int *out_edges, int **out_list, double angle));
/* extent.c */
int UTILfield_extent PTARGS((char *field_table, 
                             float *min_ext, float *max_ext));
/* face_ext.c */
int UTILexternal_faces PTARGS((int nnodes, int ncells, int cell_nnodes, int *node_list, int nfaces, 
			       int *face_nnodes, int *face_corner_nnodes, int *face_node_list, 
			       int max_sets, int *nsets, int *out_ncells, 
			       int *out_cell_nnodes, int **out_cells, int **out_lists, int *out_list_sizes));
/* fglyph.c */
int UTILglyph_func PTARGS((char *field_table, int dtype, int veclen, char *data, int null_flag, char *null_value, 
			   int scale_veclen, int color_veclen, char* scale_data, char *color_data, int vec_flag, int comp_flag, int norm_flag, double scale, int *scale_xyz,
			   float *in_xform, int g_nnodes, int g_nspace, float *g_xyz, float *xform, 
			   int out_nspace, float *out_xyz, char *out_data));
int UTILglyph PTARGS((char *field_table, int dtype, int veclen, char *data, int null_flag, char *null_value, 
		      int scale_veclen, int color_veclen, char *scale_data, char *color_data, int vec_flag, int comp_flag, int norm_flag, double scale, int *scale_xyz,  
		      float *in_xform, int g_nnodes, int g_nspace, float *g_xyz, float *xform, 
		      int out_nspace, float *out_xyz, char *out_data));
int UTILglyph_unif PTARGS((char *field_table, int dtype, int veclen, char *data, int null_flag, char *null_value,
			   int scale_veclen, int color_veclen, char *scale_data, char *color_data, int vec_flag, int comp_flag, int norm_flag, double scale, int *scale_xyz,
			   float *in_xform, int g_nnodes, int g_nspace, float *g_xyz, float *xform, 
			   int out_nspace, float *out_xyz, char *out_data));
int UTILglyph_rect PTARGS((char *field_table, int dtype, int veclen, char *data, int null_flag, char *null_value, 
			   int scale_veclen, int color_veclen, char *scale_data, char *color_data, int vec_flag, int comp_flag, int norm_flag, double scale, int *scale_xyz,
			   float *in_xform, int g_nnodes, int g_nspace, float *g_xyz, float *xform, 
			   int out_nspace, float *out_xyz, char *out_data));
/* fintegr.c */
int UTILintegrate PTARGS((char *field_table, char * block_table, int cell, char *node_data, int dtype, int veclen, int null_flag, char *null_value, double step, int order, float *start_point, float *end_point, float *start_value, float *value));
int UTILstream_line PTARGS((char *field_table, char *block_table, char *node_data, int dtype, int veclen, int null_flag, 
			    char *null_value, int order, int direct, int nseg, double min_vel, 
			    float *start_point, int max_points, int *npoints, float *points, float *values, 
			    int store, int *cells, float *uvws, float *mags, float *times, float *end_point));
/* finterp.c */
int UTILinterpolate_data PTARGS((int nprobes, float *probe_xyz, int probe_nspace, float *xfm, 
				char *field_table, char *block_table, int ncomp, int dtype, int *veclen, char **node_data, 
				double *min, double *max, int *null_flag, double *null_value, char **out_node_data));
int UTILinterpolate_cell_data PTARGS((int nprobes, float *probe_xyz, 
	int probe_nspace, float *xfm, char *field_table, char *block_table,
	int *sets, int dtype, int veclen, char **cell_data, char *min, 
	char *max, int *null_flag, char *null_value, char *out_node_data));
/* gauss.c */
int UTILvol_integr PTARGS((char *field_table, int dim, char *node_data, int dtype, int null_flag, char *null_value, float *volume, float *mass));
int UTILvol_integr_cell_line PTARGS((char *field_table, int set, int cell, char *node_data, int dtype, int null_flag, char *null_value, float *volume, float *mass));
int UTILvol_integr_cell_tri PTARGS((char *field_table, int set, int cell, char *node_data, int dtype, int null_flag, char *null_value, float *volume, float *mass));
int UTILvol_integr_cell_quad PTARGS((char *field_table, int set, int cell, char *node_data, int dtype, int null_flag, char *null_value, float *volume, float *mass));
int UTILvol_integr_cell_tet PTARGS((char *field_table, int set, int cell, char *node_data, int dtype, int null_flag, char *null_value, float *volume, float *mass));
int UTILvol_integr_cell_hex PTARGS((char *field_table, int set, int cell, char *node_data, int dtype, int null_flag, char *null_value, float *volume, float *mass));
int UTILvol_integr_cell_prism PTARGS((char *field_table, int set, int cell, char *node_data, int dtype, int null_flag, char *null_value, float *volume, float *mass));
/* gen_data.c */
int UTILgen_data PTARGS((int nnodes, int veclen, int comp, int dtype, char *data, int nspace, float *xyz, float *coeff, int null_flag, double null_value));
/* interpol.c */
int UTILinterp_cell_uvw PTARGS((char *field_table, int cell, float *point, int inside, double tol, float *uvw));
int UTILinterp_cell_val PTARGS((char *field_table, int cell, int veclen, char *node_data, int dtype, int null_flag, char *null_value, int nval, float *uvw, float *output));
int UTILinterp_cell_uvw_struct PTARGS((char *field_table, int cell, float *point, int inside, double tol, float *uvw));
int UTILinterp_cell_uvw_unif PTARGS((char *field_table, int cell, float *point, int inside, double tol, float *uvw));
int UTILinterp_cell_uvw_rect PTARGS((char *field_table, int cell, float *point, int inside, double tol, float *uvw));
int UTILinterp_cell_val_struct PTARGS((char *field_table, int cell, int veclen, char *node_data, int dtype, int null_flag, char *null_value, int nval, float *uvw, float *output));
/* iso_fnc.c */
int UTILisosurf PTARGS((char *field_table, char *node_data, int data_type, int null_flag, char *null_value, double level,
			int *out_nnodes, int **min_nodes, int **max_nodes,
			int *out_ncells_line, int **out_conn_list_line, int *conn_size_line, 
			int *out_ncells_tri, int **out_conn_list_tri, int *conn_size_tri, 
			int *ncell, int **cell_ind));
int UTILslice_cells PTARGS((char *field_table, char *node_data, int data_type, int null_flag, char *null_value, double level, 
			    int *out_nnodes, int **min_nodes, int **max_nodes, 
			    int *out_ncells_line, int **out_conn_list_line, int *conn_size_line, 
			    int *out_ncells_tri, int **out_conn_list_tri, int *conn_size_tri, 
			    int * ncell, int **cell_ind));
int UTILedge_table_add_points PTARGS((char *edge_table, int *node1_list, int *node2_list, int npts, int *pts));
int UTILedge_table_get_free PTARGS((char *edge_table, int **min_node_list, int **max_node_list, int *size));
char *UTILedge_table_create PTARGS((int size));
int UTILedge_table_delete PTARGS((char *edge_table));
/* iso_stct.c */
int UTILslice_struct PTARGS((char *field_table, char *node_data, int dtype, int null_flag, char *null_value, double iso_val, 
			     int *out_nnodes, int **min_nodes, int **max_nodes, 
			     int *out_ncells_line, int **out_conn_list_line, int *conn_size_line, 
			     int *out_ncells_tri, int **out_conn_list_tri, int *conn_size_tri, 
			     int *ncell, int **cell_ind));
int UTILedge_table_clean PTARGS((char *edge_table, int clean_size));
int UTILedge_table_add_str PTARGS((char *edge_table, int *node1_list, int *node2_list, int offset, int npts, int *pts));
int UTILedge_table_free_str PTARGS((char *edge_table, int **min_node_list, int **max_node_list, int *nnodes));
char *UTILedge_table_create_str PTARGS((int size, int block));
int UTILedge_table_delete_str PTARGS((char *edge_table));
/* iso_trc.c */
int UTILiso_trace PTARGS((char *field_table, char *block_table, char *node_data, int dtype, int null_flag, char *null_value, float *xyz, double *iso_val, int *out_nnodes, int **min_nodes, int **max_nodes, int *out_ncells, int **out_conn_list, int *conn_size));
char *UTILcell_table_create PTARGS((int size, int ncells));
int UTILcell_table_delete PTARGS((char *table));
int UTILcell_table_add PTARGS((char *table, int cell));
int UTILcell_in_table PTARGS((char *table, int cell));
int UTILedge_table_add_hash_points PTARGS((char *edge_table, int *node1_list, int *node2_list, int nnodes, int npts, int *pts));
int UTILisoline_trace PTARGS((char *field_table, char *block_table, char *node_data, int dtype, int null_flag, char *null_value, float *xyz, double *iso_val, int *out_nnodes, int **min_nodes, int **max_nodes, int *out_ncells, int **out_conn_list, int *conn_size));
/* isoline.c */
int UTILisoline PTARGS((char *field_table, char *node_data, int data_type, int null_flag, char *null_value, double level, int *out_nnodes, int **min_nodes, int **max_nodes, int *out_ncells, int **out_conn_list, int *conn_size, int *ncell, int **cell_ind));
int UTILisoline_cells PTARGS((char *field_table, char *node_data, int data_type, int null_flag, char *null_value,double level, int *out_nnodes, int **min_nodes, int **max_nodes, int *out_ncells, int **out_conn_list, int *conn_size, int *ncell, int **cell_ind));
int UTILisoline_struct PTARGS((char *field_table, char *node_data, int data_type, int null_flag, char *null_value,double level, int *out_nnodes, int **min_nodes, int **max_nodes, int *out_ncells, int **out_conn_list, int *conn_size, int *ncell, int **cell_ind));
/* jacobian.c */
float UTILjacobian_1d_det PTARGS((int num_nodes, float *derivs, float n_xyz[][3]));
float UTILjacobian_2d_det PTARGS((int num_nodes, float *derivs, float n_xyz[][3]));
float UTILjacobian_3d_det PTARGS((int num_nodes, float *derivs, float n_xyz[][3]));
/* least_sq.c */
int UTILleast_squares PTARGS((int n, float *x, int type, char *y, int ncoef, double *coeff));
int UTILeval_polynom PTARGS((int ncoef, double *coeff, int n, 
                             float *x, char *y, int type));
/* optm_srf.c */
int UTILoptimize_surface PTARGS((int *dims, int nspace, float *points, 
                                 int dtype, char *data, double eps,
                                 int *nnodes, float **coord, int *ntri, 
                                 int **conn, char **out_data));
/* param.c */
int UTILeval_coord PTARGS((char *field_table, int nnodes, int *min_node_list, int *max_node_list, float *t, float *out_data));
int UTILeval_param_coord PTARGS((char *field_table, int nnodes, int *min_node_list, int *max_node_list, float *t, float *out_data));
int UTILeval_param_coord_unif PTARGS((char *field_table, int nnodes, int *min_node_list, int *max_node_list, float *t, float *coord));
int UTILeval_param_coord_rect PTARGS((char *field_table, int nnodes, int *min_node_list, int *max_node_list, float *t, float *coord));
int UTILget_param PTARGS((int nnodes, int dtype, char *node_data, double level, int *min_node_list, int *max_node_list, float *t));
int UTILeval_param PTARGS((int nnodes, int veclen, int dtype, char *in_data, int null_flag, char *null_value, int *min_node_list, int *max_node_list, float *t, char *out_data));
int UTILget_coord_list PTARGS((char *field_table, int nnodes, int *nlist, float *coord));
int UTILcoord_list PTARGS((char *field_table, int size, int *nlist, float *coord));
int UTILcoord_list_struct PTARGS((char *field_table, int nnodes, int *nlist, float *coord));
int UTILcoord_list_unif PTARGS((char *field_table, int nnodes, int *nlist, float *coord));
int UTILcoord_list_rect PTARGS((char *field_table, int nnodes, int *nlist, float *coord));
int UTILget_data_list PTARGS((char *field_table, int data_type, int veclen, char *node_data, int nnodes, int *node_ind, char *out_data));
int UTILdata_list PTARGS((char *field_table, int data_type, int veclen, char *node_data, int nnodes, int *node_ind, char *out_data));
int UTILdata_list_struct PTARGS((char *field_table, int data_type, int veclen, char *node_data, int nnodes, int *node_ind, char *out_data));
/* rev_par.c */
int UTILrev_par_line_1 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_line_2 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_tri_1 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_quad_1 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_tri_2 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_quad_2 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_tet_1 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_pent_1 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_pyr_1 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_hex_1 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_tet_2 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_pent_2 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
int UTILrev_par_hex_2 PTARGS((float n_xyz[][3], float p_xyz[3], float *uvw));
/* ribbon.c */
int UTILribbon PTARGS((char *field_table, int npoints, int nspace, float *points, float *values, int *cells, 
		       float *uvws, float *mags, float *times, int veclen, char *node_data, int dtype, 
		       int null_flag, char *null_value, double width0, double angle0, float *width_end, float *angle_end));
/* roi_util.c */
int UTILroi_sort_verts PTARGS((int nspace, float *xyz, int *poly_line,
		        int start_angle, int *list, float *t));
int UTILroi_connect_verts PTARGS((int n0, int n1, int *list0, int * list1,
			  float *t0, float *t1, int *ntri, int *conn));
/* sctintrp.c */
int UTILscat_interp_alloc PTARGS((int nnodes, int ndim, int *dims, char **block_table));
int UTILscat_interp_end PTARGS((char *block_tbl));
int UTILscat_interp_init PTARGS((int nnodes, int nspace, float *xyz, float *min_xyz, float *max_xyz, int ndim, int *dims, char **block_table));
int UTILscat_data_interp PTARGS((char *block_table, int nnodes, int nspace, float *xyz, int dtype, int veclen, char *in_data, float *min_xyz, float *max_xyz, int ndim, int *dims, int *depth, int order, int *null_flag, char *null_value, char *out_data));
int UTILscat_data_interp2 PTARGS((int nnodes, int nspace, float *xyz, 
        int dtype, int veclen, char *in_data, float *min_xyz, float *max_xyz,
        int ndim, int *dims, int *depth, int order, int *null_flag, 
        char *null_value, char *out_data));
/* shape.c */
void UTILsh_func_line_1 PTARGS((float *uvw, float sh_func[2]));
void UTILsh_deriv_line_1 PTARGS((float *uvw, float sh_func_deriv[2]));
void UTILsh_func_line_2 PTARGS((float *uvw, float sh_func[3]));
void UTILsh_deriv_line_2 PTARGS((float *uvw, float sh_func_deriv[3]));
void UTILsh_func_tri_1 PTARGS((float *uvw, float sh_func[3]));
void UTILsh_deriv_tri_1 PTARGS((float *uvw, float sh_func_deriv[2][3]));
void UTILsh_func_quad_1 PTARGS((float *uvw, float sh_func[4]));
void UTILsh_deriv_quad_1 PTARGS((float *uvw, float sh_func_deriv[2][4]));
void UTILsh_func_tri_2 PTARGS((float *uvw, float sh_func[6]));
void UTILsh_deriv_tri_2 PTARGS((float *uvw, float sh_func_deriv[2][6]));
void UTILsh_func_quad_2 PTARGS((float *uvw, float sh_func[8]));
void UTILsh_deriv_quad_2 PTARGS((float *uvw, float sh_func_deriv[2][8]));
void UTILsh_func_pent_1 PTARGS((float *uvw, float sh_func[6]));
void UTILsh_deriv_pent_1 PTARGS((float *uvw, float sh_func_deriv[3][6]));
void UTILsh_func_hex_1 PTARGS((float *uvw, float sh_func[8]));
void UTILsh_deriv_hex_1 PTARGS((float *uvw, float sh_func_deriv[3][8]));
void UTILsh_func_pyr_1 PTARGS((float *uvw, float sh_func[5]));
void UTILsh_deriv_pyr_1 PTARGS((float *uvw, float sh_func_deriv[3][5]));
void UTILsh_func_tet_1 PTARGS((float *uvw, float sh_func[4]));
void UTILsh_deriv_tet_1 PTARGS((float *uvw, float sh_func_deriv[3][4]));
void UTILsh_func_tet_2 PTARGS((float *uvw, float sh_func[10]));
void UTILsh_deriv_tet_2 PTARGS((float *uvw, float sh_func_deriv[3][10]));
void UTILsh_func_pent_2 PTARGS((float *uvw, float sh_func[15]));
void UTILsh_deriv_pent_2 PTARGS((float *uvw, float sh_func_deriv[3][15]));
void UTILsh_func_hex_2 PTARGS((float *uvw, float sh_func[20]));
void UTILsh_deriv_hex_2 PTARGS((float *uvw, float sh_func_deriv[3][20]));
/* slice.c */
int UTILrslice PTARGS((char *field_table, int *dims, float *points, float *plane_norm, double plane_dist, int *out_dims, float **out_points, int out_nspace, float *xform, int **min_node, int **max_node, float **t, char **list));
int UTILrslice_unif PTARGS((int *dims, float *points, float *plane_norm, double plane_dist, int *out_dims, float **out_points, int out_nspace, float *xform, int **min_node, int **max_node, float **t, char **list));
int UTILrslice_rect PTARGS((int *dims, float *points, float *plane_norm, double plane_dist, int *out_dims, float **out_points, int out_nspace, float *xform, int **min_node, int **max_node, float **t, char **list));
/* struct.c */
int UTILget_coords_unif PTARGS((int ndim, int *dims, int nspace, float *points, int min_node, int max_node, int min_space, int max_space, float *array));
int UTILget_coords_rect PTARGS((int ndim, int *dims, int nspace, float *points, int min_node, int max_node, int min_space, int max_space, float *array));
int UTILget_connect_struct PTARGS((int ndim, int *dims, int min_cell, int max_cell, int *array));
/* thresh.c */
int UTILthresh_null PTARGS((char *field_table, char *node_data, int data_type, char *null_data_value, int *old_nnodes, int **node_ind, int nsets, int *out_ncells, int **out_conn_list, int *conn_size));
int UTILthresh_null_cells PTARGS((char *field_table, char *node_data, int data_type, char *null_data_value, int *old_nnodes, int **node_ind, int nsets, int *out_ncells, int **out_conn_list, int *conn_size));
int UTILcells_from_nlist PTARGS((char *field_table, int set, int old_nnodes, int *node_ind, int *out_ncells, int **nlist, int *nsize));
int UTILnode_thresh_null PTARGS((int nnodes, int data_type, char *node_data, char *null_value, int *node_ind));
int UTILthresh_null_struct PTARGS((char *field_table, char *node_data, int data_type, char *null_data_value, int *old_nnodes, int **node_ind, int nsets, int *out_ncells, int **out_conn_list, int *conn_size));
/* vec_null.c */
int UTILderiv_null PTARGS((char *mesh_info, char *node_data, int veclen, int dtype, char *null_value, int out_veclen, float *out_node_data));
int UTILderiv_null_struct PTARGS((char *mesh_info, char *node_data, int veclen, int dtype, char *null_value, int out_veclen, float *out_node_data));
/* vec_rect.c */
int UTILcurl_rect_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[][3]));
int UTILgrad_rect_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[]));
int UTILgrad_rect_2d PTARGS((int *dims, int nspace, float xyz[], char *src, int dtype, float dst[]));
int UTILdiv_rect_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[]));
/* vec_strc.c */
int UTILcurl_struct_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[][3]));
int UTILgrad_struct_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[]));
int UTILgrad_struct_2d PTARGS((int *dims, int nspace, float xyz[], char *src, int dtype, float dst[]));
int UTILdiv_struct_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[]));
/* vec_unif.c */
int UTILcurl_unif_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[][3]));
int UTILgrad_unif_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[]));
int UTILgrad_unif_2d PTARGS((int *dims, int nspace, float xyz[], char *src, int dtype, float dst[]));
int UTILdiv_unif_3d PTARGS((int *dims, float xyz[], char *src, int dtype, float dst[]));

#ifdef __cplusplus
} /* extern "C" */
#endif
